
// domain.h

#ifndef _JUDE_MATH_DOMAIN_H
#define _JUDE_MATH_DOMAIN_H

#include <math.h>

namespace jude {
namespace math {



class DomainX {

  double min_inc;
  double max_inc;
  int step_count;

public:

  Domain() { }

  Domain(double v) :
    min_inc(v),
    max_inc(v),
    step_count(0) { }

  Domain(double mn, double mx, int sc) :
    min_inc(mn),
    max_inc(mx),
    step_count(sc) { }

  double min() const { return min_inc; }
  double max() const { return max_inc; }
  int stepCount() const { return step_count; }

  double stepValue(int s) const { return step_count ? (min_inc + (s * (max_inc - min_inc)) / step_count) : min_inc; }
};



} } // namespace jude::math

#endif // _JUDE_MATH_DOMAIN_H

